﻿using UnityEngine;
using System.Collections;

public class Clyde : Ghost {

	public Clyde(bool menu_static) {
		//Clyde's starting data
		primaryColor = new Color(255/255f,184/255f,71/255f);

		startingPos.x = 16f;
		startingPos.y = -14.5f;

		start_mode = GhostMode.GHOSTHOUSE;
		start_dir = _dir = move_dir = Dir.DOWN;
		speed = 0.5f;

		homePos.x = 0;
		homePos.y = 32;
		name = "Clyde";

		if(menu_static)
			menuStatic();
		else
			init ();
	}

	public override void update (float deltaTime)
	{
		base.update (deltaTime);
	}

	protected override void findTarget ()
	{
		//Clyde can seem unpredictible as he will appear to run away from Pac-man if he gets too close.
		//specifically is Pac-man is within 8 tiles of Cylde, then Clyde's target becomes the corner home target (bottom left)
		//otherwise Clyde will follow the smae targeting rule as Blinky and head directly for Pac-man.
		//meaning that if both Blinky and Clyde are in prusuit of pacman then Cylde is likely to break off at some point, potentially closing off an escape route for pacman
		if(_mode != GhostMode.EYES1 && _mode == GhostMode.CHASE){
			Pacman pacman = GameManager.Instance.pacman;
			if(Vector2.Distance(pos, pacman.pos) > 8){
				target.x = pacman.pos.x;
				target.y = pacman.pos.y;
			} else{
				target = homePos;
			}
		} else {
			base.findTarget ();
		}
	}

	//Clyde's dot limit for exiting the ghost house.
	//from the 3rd level onwards clyde leave right away.
	public override int dotsLimit ()
	{
		int d = 0;
		switch(GameManager.Instance.level){
			case 1: 
				d = 60; 
				break;
			case 2: 
				d = 50; 
				break;
		}
		return d;
	}
}
