﻿using UnityEngine;
using System.Collections;

public class Inky : Ghost {

	public Inky(bool menu_static) {
		//Inky's starting data
		primaryColor = new Color(0/255f,255/255f,222/255f);
		startingPos.x = 12f;
		startingPos.y = -14.5f;
		
		start_mode = GhostMode.GHOSTHOUSE;
		start_dir = _dir = move_dir = Dir.DOWN;
		speed = 0.5f;

		name = "Inky";

		homePos.x = 28;
		homePos.y = 32;

		if(menu_static)
			menuStatic();
		else
			init ();
	}

	protected override void findTarget ()
	{
		//Inky uses both Pac-man AND Blinky's positions to determine its target.
		//Inky find the tile 2 tiles in front of Pac-man (similar to Pinky's 4)
		//then finds the vector from blinky to that point
		//that vector is then doubled (away from Blinky) with the target being the far endpoint.
		if(_mode != GhostMode.EYES1 && _mode == GhostMode.CHASE){
			Pacman pacman =  GameManager.Instance.pacman;
			Blinky blinky = GameManager.Instance.blinky;
			target.x = pacman.pos.x;
			target.y = pacman.pos.y;
			switch(pacman.moveDir){
			case Dir.LEFT:
				target.x -= 2;
				break;
			case Dir.RIGHT:
				target.x += 2;
				break;
			case Dir.UP:
				target.y -= 2;
				//reproducing the buffer overflow bug! :D I'm trying to be as exact as I can here! 
				//a design flaw in the hardware meant then when pacman was facing up, a point 'n' tiles in front would also be 'n' to the left
				target.x -= 2;
				break;
			case Dir.DOWN:
				target.y += 2;
				break;
			}
			target.x += target.x - blinky.pos.x;
			target.y += target.y - blinky.pos.y;
		} else {
			base.findTarget ();
		}
	}

	//Inky's dot limit for when to leave the Ghost house.
	//after the first level inky always leaves right away.
	public override int dotsLimit ()
	{
		int d = 0;
		switch(GameManager.Instance.level){
			case 1: d = 30; break;
		}
		return d;
	}
}
