﻿using UnityEngine;
using System.Collections;


// a simple two stage menu/intro screen
// it's just a bunch of words mostly
// the original had an animation on the first screen after the ghosts are introduced as they are here.
// it shows the 4 ghosts chasing pacman in the line right-to-left, then pacman eats a pill and chases ghosts left-to-right, eating each in turn and showing the bonus scores.
// was this the first ever tutorial?

public class Menu {

	//stage 1: this is all the stuff for the first screen.
	// basically an introduction to the ghosts and a kind of description of their description (the translation from Japanese is a bit suspect).
	Blinky blinky_static;
	Pinky pinky_static;
	Inky inky_static;
	Clyde clyde_static;
	
	Word character;
	Word shadow;
	Word blinky_word;
	Word speedy;
	Word pinky_word;
	Word bashful;
	Word inky_word;
	Word pokey;
	Word clyde_word;
	Word midway;
	Word p10;
	Word p50;
	Bonus pts10;
	Bonus pts50;
	GameObject dot;
	GameObject pill;

	//stage 2
	Word anyButton;
	Word oneplayer;
	Word bonus_pacman;
	Word midway2;
	Word ported;
	Word mememe;
	Bonus pts_bonus_pacman;

	int stage = 0;
	int step = 0;
	int frame_timer = 0;

	public Menu(){

		blinky_static = new Blinky(true);
		blinky_static.setPosition(4f,-4f);

		pinky_static = new Pinky(true);
		pinky_static.setPosition(4f,-7f);

		inky_static = new Inky(true);
		inky_static.setPosition(4f,-10f);

		clyde_static = new Clyde(true);
		clyde_static.setPosition(4f,-13f);

		Color white = new Color(222/255f,222/255f,222/255f);

		character = new Word("CHARACTER / NICKNAME", new Vector3(7f, -2f, -1f), white);
		shadow = new Word("-SHADOW", new Vector3(7f, -4f, -1f), blinky_static.color);
		blinky_word = new Word("\"BLINKY\"", new Vector3(18f, -4f, -1f), blinky_static.color);

		speedy = new Word("-SPEEDY", new Vector3(7f, -7f, -1f), pinky_static.color);
		pinky_word = new Word("\"PINKY\"", new Vector3(18f, -7f, -1f), pinky_static.color);

		bashful = new Word("-BASHFUL", new Vector3(7f, -10f, -1f), inky_static.color);
		inky_word = new Word("\"INKY\"", new Vector3(18f, -10f, -1f), inky_static.color);

		pokey = new Word("-POKEY", new Vector3(7f, -13f, -1f), clyde_static.color);
		clyde_word = new Word("\"CLYDE\"", new Vector3(18f, -13f, -1f), clyde_static.color);

		midway = new Word("@ 1980 MIDWAY MFG. CO.", new Vector3(4f, -28f, -1f), pinky_static.color);

		dot = Map.newObj(10, 21, ObjTypes.DOT);
		dot.transform.Translate(new Vector3(-0.5f, 0.5f));
		p10 = new Word("10", new Vector3(12f, -21f, -1f), white);
		pts10 = new Bonus();
		pts10.text(-1, new Vector2(15f, 21f), white);

		pill = Map.newObj(10, 23, ObjTypes.PILL);
		pill.transform.Translate(new Vector3(-0.5f, 0.5f));
		p50 = new Word("50", new Vector3(12f, -23f, -1f), white);
		pts50 = new Bonus();
		pts50.text(-1, new Vector2(15f, 23f), white);

		anyButton = new Word("PUSH ANY BUTTON", new Vector3(7f, -17f, -1f), clyde_static.color);
		oneplayer = new Word("1 PLAYER ONLY", new Vector3(8f, -20f, -1f), inky_static.color);
		bonus_pacman = new Word("BONUS PAC-MAN FOR 10000", new Vector3(2f, -23f), new Color(242/255f, 178/255f, 165/255f));
		pts_bonus_pacman = new Bonus();
		pts_bonus_pacman.text(-1, new Vector2(26f, 23f), white);
		midway2 = new Word("@ 1980 MIDWAY MFG. CO.", new Vector3(4f, -26f, -1f), pinky_static.color);
		ported = new Word("PORTED TO UNITY BY:", new Vector3(5.5f, -28f, -1f), white);
		mememe = new Word("OWEN CANAVAN", new Vector3(8.5f, -29f, -1f), white);

		stop ();
	}
	public void stop(){
		blinky_static.enabled = false;
		pinky_static.enabled = false;
		inky_static.enabled = false;
		clyde_static.enabled = false;

		character.enabled = false;
		shadow.enabled = false;
		blinky_word.enabled = false;
		speedy.enabled = false;
		pinky_word.enabled = false;
		bashful.enabled = false;
		inky_word.enabled = false;
		pokey.enabled = false;
		clyde_word.enabled = false;
		midway.enabled = false;
		dot.SetActive(false);
		p10.enabled = false;
		pts10.enabled = false;
		pill.SetActive(false);
		p50.enabled = false;
		pts50.enabled = false;

		anyButton.enabled = false;
		oneplayer.enabled = false;
		bonus_pacman.enabled = false;
		pts_bonus_pacman.enabled = false;
		midway2.enabled = false;
		ported.enabled = false;
		mememe.enabled = false;
	}

	public void start(){
		stop ();
		step = 0;
		stage = 1;
		frame_timer = 60;
		character.enabled = true;
	}

	public virtual void update(float deltaTime){
		frame_timer--;
		if(stage == 1){
			//sequence for when to show each item in stage 1. wait n number of frames then proceed to the next step.
			if(Input.GetKeyUp(KeyCode.Alpha1) || Input.GetKeyUp(KeyCode.Space)){ //press one (or space since 1 won't work in maximized mode?) to go to the next screen. will automatically do so ten seconds after the sequence is complete
				nextStage();
				return;
			}
			if(frame_timer == 0){
				step++;
				switch(step){
					case 1: blinky_static.enabled = true; frame_timer = 50; break;
					case 2: shadow.enabled = true; frame_timer = 20; break;
					case 3: blinky_word.enabled = true; frame_timer = 20; break;
					case 4: pinky_static.enabled = true; frame_timer = 50; break;
					case 5: speedy.enabled = true; frame_timer = 20; break;
					case 6: pinky_word.enabled = true; frame_timer = 20; break;
					case 7: inky_static.enabled = true; frame_timer = 50; break;
					case 8: bashful.enabled = true; frame_timer = 20; break;
					case 9: inky_word.enabled = true; frame_timer = 20; break;
					case 10: clyde_static.enabled = true; frame_timer = 50; break;
					case 11: pokey.enabled = true; frame_timer = 20; break;
					case 12: clyde_word.enabled = true; frame_timer = 60; break;
					case 13: 
						dot.SetActive(true);
						p10.enabled = true;
						pts10.enabled = true;
						pill.SetActive(true);
						p50.enabled = true;
						pts50.enabled = true;
						frame_timer = 20;
						break;
					case 14: midway.enabled = true; frame_timer = 600; break;
					case 15 : nextStage(); break;
				}
			}
		} else if(stage == 2){ //any key to start game or auto-start after 10 seconds
			if(Input.anyKey || frame_timer == 0){
				nextStage();
			}
		}
	}

	protected void nextStage(){
		if(stage == 1){
			stop ();
			stage++;
			
			anyButton.enabled = true;
			oneplayer.enabled = true;
			bonus_pacman.enabled = true;
			pts_bonus_pacman.enabled = true;
			midway2.enabled = true;
			ported.enabled = true;
			mememe.enabled = true;
			frame_timer = 600;
			step = 0;
			return;
		} else {
			stop();
			GameManager.Instance.StartFromMenu();
		}
	}
}
