﻿using UnityEngine;
using System.Collections;

public class Pinky : Ghost {

	public Pinky(bool menu_static) {
		//Pinky's specific starting data
		primaryColor = new Color(255/255f,184/255f,222/255f);
		startingPos.x = 14f;
		startingPos.y = -14.5f;
		
		start_mode = GhostMode.GHOSTHOUSE;
		start_dir = _dir = move_dir = Dir.UP;
		speed = 0.5f;


		homePos.x = 2;
		homePos.y = -4;
		name = "Pinky";

		if(menu_static)
			menuStatic();
		else
			init ();
	}

	protected override void findTarget ()
	{
		//When in chase mode Pinky tries to get to a spot 4 tiles in front of Pac-Mans position (based on pacmans moving direction)
		//this can cause Pinky to avoid pacman when directly in front, if the distance from the taget to that new tile is shorter than to pacmans tile
		//a good player can use this behaviour to force Pinky to move away from pacman (a quick back and forth change of direction while pinky is at a junction)
		if(_mode != GhostMode.EYES1 && _mode == GhostMode.CHASE){
			Pacman pacman =  GameManager.Instance.pacman;
			target.x = pacman.pos.x;
			target.y = pacman.pos.y;
			switch(pacman.moveDir){
				case Dir.LEFT:
					target.x -= 4;
					break;
				case Dir.RIGHT:
					target.x += 4;
					break;
				case Dir.UP:
					target.y -= 4;
					//reproducing the buffer overflow bug! :D I'm trying to be as exact as I can here! 
					//a design flaw in the hardware meant then when pacman was facing up, a point 'n' tiles in front would also be 'n' to the left
					target.x -= 4;
					break;
				case Dir.DOWN:
					target.y += 4;
					break;
			}
		} else {
			base.findTarget ();
		}
	}
}
